Subject: Re: [PATCH 2/8] odb: resolve relative alternative paths when parsing

From: Patrick Steinhardt <[email-masked]>
Date: Wed, 10 Dec 2025 06:53:51 +0100

On Tue, Dec 09, 2025 at 12:06:09PM -0600, Justin Tobler wrote:
> On a semi-related note, part of me thinks it would be nice if alternate
> sources were a bit more first class in `struct object_database`. IOW,
> explicitly defining the primary and list of alternate sources
> separately. From the perspective of reading objects, having a single
> list of sources is nice, but when writing objects only the first source
> is used. This isn't too big of a deal, but certain operations like ODB
> trasactions will reorder the source list to change where objects get
> written to which feels a bit fragile to me. I guess another way to
> resolve this concern could be to change ODB transactions to use a
> separate mechanism though.

Agreed, especially the writing side is a bit weird, and reordering
sources when we create transactions is one of the weirdest parts. I
think this is out of scope for this patch series, but I certainly think
that we should address this by polishing the ODB transactions a bit
going forward.

Thanks!

Patrick